unit U_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, FileCtrl, StdCtrls, Spin, Buttons;

type
  TF_main = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    BB_Fmg2Tmpl: TBitBtn;
    BB_Close: TBitBtn;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    BB_font: TBitBtn;
    BB_Grid: TBitBtn;
    Panel2: TPanel;
    Label1: TLabel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    B_mark_all: TButton;
    B_unmark_all: TButton;
    B_refresh: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    BB_align_left: TBitBtn;
    BB_align_top: TBitBtn;
    BB_align_right: TBitBtn;
    BB_align_bottom: TBitBtn;
    BB_align_center_h: TBitBtn;
    BB_align_center_v: TBitBtn;
    BB_squeez_h: TBitBtn;
    BB_expand_h: TBitBtn;
    BB_squeez_v: TBitBtn;
    BB_expand_v: TBitBtn;
    Bevel1: TBevel;
    Bevel2: TBevel;
    SE_skip: TSpinEdit;
    BB_move_left: TBitBtn;
    BB_move_right: TBitBtn;
    BB_move_down: TBitBtn;
    BB_move_up: TBitBtn;
    BB_undo: TBitBtn;
    procedure FileListBox1Change(Sender: TObject);
    procedure B_refreshClick(Sender: TObject);
    procedure BB_CloseClick(Sender: TObject);
    procedure BB_Fmg2TmplClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BB_fontClick(Sender: TObject);
    procedure BB_align_leftClick(Sender: TObject);
    procedure BB_align_rightClick(Sender: TObject);
    procedure BB_align_topClick(Sender: TObject);
    procedure BB_align_bottomClick(Sender: TObject);
    procedure BB_align_center_hClick(Sender: TObject);
    procedure BB_align_center_vClick(Sender: TObject);
    procedure BB_squeez_hClick(Sender: TObject);
    procedure BB_squeez_vClick(Sender: TObject);
    procedure BB_expand_hClick(Sender: TObject);
    procedure BB_expand_vClick(Sender: TObject);
    procedure BB_move_leftClick(Sender: TObject);
    procedure BB_move_rightClick(Sender: TObject);
    procedure BB_move_upClick(Sender: TObject);
    procedure BB_move_downClick(Sender: TObject);
    procedure B_unmark_allClick(Sender: TObject);
    procedure B_mark_allClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BB_undoClick(Sender: TObject);
  private
    Act_dir  ,  App_Dir   : string;
    { Private declarations }
  public
    { Public declarations }
  end;


const
  n     =  100;
  n2000 = 3000;

  nl =#13#10;
  wi_min=800;
  he_min=600;

type
  rec_font = record
    control_fontsize:integer;
    control_fontname,
    control_fontbold,
    control_fontitalic,
    control_fontunderline,
    control_fontstrikeout:string;
  end;

  rec_dimension = record
    control_top,
    control_left,
    control_width,
    control_height : integer
  end;

  rec_control = record
    num     : byte;
    checked : boolean;
    control_type,
    control_name : string;
    control_dim  : rec_dimension;
    control_font : rec_font
  end;

var
  F_main: TF_main;
  count_of_controls       : integer;

  a_controls,
  a_controls_undo         : array[1..n] of rec_control ;
  a_check                 : array[1..n] of byte ;
  i_count_checked         : integer;


  a_input : array[1..n2000]of string;
  i2000:integer;

implementation

{$R *.DFM}

procedure mess1; begin  MessageDlg('To perform ALIGN'       +nl+'at least 2 controls should be checked.', mtWarning, [mbOk], 0) end;
procedure mess2; begin  MessageDlg('To perform MOVE'        +nl+'at least 1 control  should be checked.', mtWarning, [mbOk], 0) end;
procedure mess3; begin  MessageDlg('To perform REDIMENSION' +nl+'at least 1 control  should be checked.', mtWarning, [mbOk], 0) end;
procedure mess4; begin  MessageDlg('Program terminated.'    +nl+nl+'n2000 value should be increased to '+IntToStr(i2000)      , mtError  , [mbOk], 0) end;
procedure mess5; begin  MessageDlg('Program terminated.'    +nl+nl+'n value should be increased to '+IntToStr(count_of_controls)      , mtError  , [mbOk], 0) end;

{========================================}
{========================================}
{========================================}

procedure TF_main.FileListBox1Change(Sender: TObject);
var
  Code:integer;
  ffile,
  s_control_type,
  s_control_name:string;
  s_string : array [1..6] of string;
  l_overflow1,l_overflow2 : boolean;

  procedure elaborate_fmg;
  var
    s:string;
    i_pos_x,i_pos_y,i_width,i_height : integer;
    l_main_window : boolean;
    Bitmap: TBitmap;

          {----------------------------}

          function extract_value_from_string( par_s_marker:string):integer;
          var
            substr:string;
            i_result:integer;
            i_from, i_to :integer;
          begin
            i_from := Pos(par_s_marker, s);
            inc(i_from, length(par_s_marker));
            substr := copy( s, i_from, length(s)-i_from+1);
            i_to := Pos(' ', substr);
            if i_to > 0 then substr := copy( substr, 1, i_to-1);
            Val ( substr, i_result, Code );
            if Code <> 0 then begin
              MessageDlg(s_control_name+' '+par_s_marker+' - Err at: ' + IntToStr(Code), mtError, [mbOk], 0);
              Halt
            end;
            extract_value_from_string := i_result;
          end;

          {----------------------------}

          function extract_name_from_string( par_s_marker:string):string;
          var
            substr:string;
            i_from, i_to :integer;
          begin
            i_from := Pos(par_s_marker, s);
            inc(i_from, length(par_s_marker));
            substr := copy( s, i_from, length(s)-i_from+1);
            i_to := Pos(' ', substr);
            if i_to > 0 then substr := copy( substr, 1, i_to-1);

            extract_name_from_string := substr;
          end;

          {----------------------------}

          procedure update_a_controls_array;
          begin
            inc(count_of_controls);

            if count_of_controls<=n then begin
              with a_controls[count_of_controls] do begin
                num            := 0;
                checked        := false;
                control_type   := s_control_type;
                control_name   := s_control_name
              end;

              with a_controls[count_of_controls].control_dim do begin
                control_top    := i_pos_y ;
                control_left   := i_pos_x ;
                control_width  := i_width ;
                control_height := i_height;
              end;
            end else l_overflow2:=true;

          end;

          {----------------------------}

          procedure resize_image_and_form;
          var
            wi_max,
            he_max:integer;
          begin
            Bitmap := TBitmap.Create;
            try
              with Bitmap do begin
                Width  := i_width;
                Height := i_height;
              end;
              Image1.Picture.Graphic :=BitMap;
            finally
              Bitmap.Free;
            end;


            wi_max := SpinEdit1.Value;
            he_max := SpinEdit2.Value;

            i_width  := i_width  + Panel2.Width  + 18;  if i_width  > wi_max then i_width  := wi_max;
                                                        if i_width  < wi_min then i_width  := wi_min;
            i_height := i_height + Panel1.Height + 42;  if i_height > he_max then i_height := he_max;
                                                        if i_height < he_min then i_height := he_min;
            with F_main do begin
              Width    := i_width  ;
              Height   := i_height ;
            end;
            l_main_window := false;
          end;

          {----------------------------}

          procedure font_check( par_keyword:string; par_index:integer);
          begin
            if count_of_controls>n then exit;

            if Pos( par_keyword, s)> 0 then begin
              s_string[par_index] := extract_name_from_string(' '+par_keyword+' ');
              if par_index=6 then begin
                with a_controls[count_of_controls].control_font do begin

                  control_fontname      :=           s_string[1]  ;
                  control_fontsize      := StrToInt( s_string[2] );
                  control_fontbold      :=           s_string[3]  ;
                  control_fontitalic    :=           s_string[4]  ;
                  control_fontunderline :=           s_string[5]  ;
                  control_fontstrikeout :=           s_string[6]  ;
                end;

              end;
            end;

          end;

          {----------------------------}
          procedure read_line_from_fmg_file;
          begin
            readln(Input, s);
            inc(i2000);
            if i2000<n2000 then a_input[i2000]:=s
                           else l_overflow1 := true;
          end;
          {----------------------------}



  var
    i_pos_xy_swap : integer;
  begin
    l_main_window:=true;



    i2000:=0;
    while not eof(Input) do begin
      read_line_from_fmg_file;

      if Pos(' AT ', s)> 0 then begin
        if Pos(' WINDOW ', s)> 0 then begin
          s_control_type := '';
          s_control_name := extract_name_from_string(' WINDOW ')
        end else begin
          s_control_type := extract_name_from_string(' DEFINE ');
          s_control_name := extract_name_from_string(' '+s_control_type+' ');
        end;

        i_pos_x  := extract_value_from_string(' AT ');
        i_pos_y  := extract_value_from_string(' , ');
        if s_control_type='TAB' then begin
          i_pos_xy_swap := i_pos_y;
          i_pos_y       := i_pos_x;
          i_pos_x       := i_pos_xy_swap
        end;

        i_width  := extract_value_from_string(' WIDTH ');
        i_height := extract_value_from_string(' HEIGHT ');

        if l_main_window then resize_image_and_form;


        update_a_controls_array;
      end else begin
{
    DEFINE BUTTON Button_1
        ROW    40
        COL    170
        WIDTH  100
        HEIGHT 28
}
        if Pos(' DEFINE ', s)> 0 then begin
          s_control_type := extract_name_from_string(' DEFINE ');
          s_control_name := extract_name_from_string(' '+s_control_type+' ');

                                                                           read_line_from_fmg_file;
          if Pos(' ROW ', s)> 0 then begin
            i_pos_y    := extract_value_from_string('ROW    ');            read_line_from_fmg_file;
            i_pos_x    := extract_value_from_string('COL    ');            read_line_from_fmg_file;
            i_width    := extract_value_from_string('WIDTH  ');            read_line_from_fmg_file;
            i_height   := extract_value_from_string('HEIGHT ');
            update_a_controls_array;
          end;
        end;
        font_check( 'FONTNAME'      , 1 );
        font_check( 'FONTSIZE'      , 2 );
        font_check( 'FONTBOLD'      , 3 );
        font_check( 'FONTITALIC'    , 4 );
        font_check( 'FONTUNDERLINE' , 5 );
        font_check( 'FONTSTRIKEOUT' , 6 );
      end;
    end;

  end;
  {---------------------}

begin
  ffile := FileListBox1.FileName;
  if ffile='' then exit;

  fillchar(a_controls,sizeof(a_controls),0);
  fillchar(a_check   ,sizeof(a_check   ),0);
  count_of_controls:=0;
  i_count_checked  :=0 ;
  l_overflow1:=false;
  l_overflow2:=false;

  AssignFile(Input, ffile);  Reset(Input);
  elaborate_fmg;
  CloseFile(Input);

  if l_overflow1 or  l_overflow2 then  begin
    if l_overflow1 then mess4
                   else mess5;
    halt;
  end else begin
    B_refreshClick(Sender);
    BB_undo.Visible :=false
  end;


{  MessageDlg('File loaded:'+nl+nl+ExtractFileName(ffile), mtInformation, [mbOK], 0);}

end;

{========================================}
{========================================}
{========================================}

procedure TF_main.B_refreshClick(Sender: TObject);
  {----------------------}
  function f_truncate(s:string):string;
  var
    l:integer;
    s2:string;
  begin
    l:=length(s)-2;
    if l>0 then s2 := copy (s, 2, l)
           else s2 := s;
    f_truncate := s2
  end;
  {----------------}
  procedure f_add_style(par_ctrl:string;fs_type:TFontStyle);
  begin
    if par_ctrl = '.T.' then Image1.Canvas.Font.Style :=Image1.Canvas.Font.Style + [fs_type];
  end;
  {----------------}

var
  i,j:integer;
  kol:Tcolor;
  s_control_name,s_font_name:string;
  pos_x,pos_y,i_width,i_height : integer;
  tmp_control:rec_control;

begin


  if count_of_controls>1 then begin
   Image1.Picture:=nil;
    with Image1.Canvas.Pen do begin
      Color := RGB( 0,127,255);
      Width := 2;
      Mode  := pmCopy;
      Style := psSolid
    end;

    with Image1.Canvas.Brush do begin
      Color := RGB(100,200,255);
      Style := bsSolid;
    end;
    for i:=2 to count_of_controls do begin
      tmp_control :=a_controls[i];

      with tmp_control do begin

        if checked then kol := RGB(255,  0,128)  else kol := RGB(  0,127,255);    Image1.Canvas.Pen  .Color := kol;
        if checked then kol := RGB(255,222,128)  else kol := RGB(100,200,255);    Image1.Canvas.Brush.Color := kol;

        with control_dim do begin
          pos_y    :=  control_top;
          pos_x    :=  control_left;
          i_width  :=  control_width;
          i_height :=  control_height;
        end;
        s_control_name := control_name;

        Image1.Canvas.Rectangle( pos_x   , pos_y   , pos_x+i_width , pos_y+i_height );

        with control_font do begin
          if control_fontsize >0 then begin
            Image1.Canvas.Font.Size  := control_fontsize;          s_font_name := f_truncate(control_fontname);
            Image1.Canvas.Font.Name  := s_font_name;
            Image1.Canvas.Font.Style := [];
            f_add_style ( control_fontbold     , fsBold      );
            f_add_style ( control_fontitalic   , fsItalic    );
            f_add_style ( control_fontunderline, fsUnderline );
            f_add_style ( control_fontstrikeout, fsStrikeout )
          end else begin
            Image1.Canvas.Font.Size  := 10;
            Image1.Canvas.Font.Name  := 'Arial';
            Image1.Canvas.Font.Style := [fsBold,fsItalic,fsUnderline,fsStrikeout];
          end;
        end;
        if checked then begin
          j:=0;
          repeat
            inc (j)
          until (a_check[j]=i) or (j=n);
          Image1.Canvas.TextOut  ( pos_x+2 , pos_y+2 , IntToStr(j)+' '+s_control_name )
        end else begin
          Image1.Canvas.TextOut  ( pos_x+2 , pos_y+2 , s_control_name )
        end;

      end;
    end;
  end;

  BB_undo.Visible :=true;

end;

{========================================}
{========================================}
{========================================}

procedure TF_main.BB_CloseClick(Sender: TObject);
begin
  Close
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.BB_Fmg2TmplClick(Sender: TObject);
var
  count2_of_controls:integer;

      {------------------}

      function f_elaborate2(s_in:string):string;
      var
        s_out:string;

          {----------------------------}

          procedure font_write( par_keyword:string; par_index:integer);
          var
            s_1:string;
            l1,l2,l3:integer;
          begin
            l1:=Pos( par_keyword, s_in);
            if l1> 0 then begin
              l2 := length(par_keyword);
              l3  := l1 + l2;
              s_1 := copy(s_in,1,l3);

              with a_controls[count2_of_controls].control_font do begin
                case par_index of
                  1: s_out := s_1 +          control_fontname;
                  2: s_out := s_1 + IntToStr(control_fontsize);
                  3: s_out := s_1 +          control_fontbold;
                  4: s_out := s_1 +          control_fontitalic;
                  5: s_out := s_1 +          control_fontunderline;
                  6: s_out := s_1 +          control_fontstrikeout;
                end;
              end;

            end;
          end;
          {----------------------------}
          procedure dim__write( par_keyword:string; par_index:integer);
          var
            s_1:string;
            l1,l2,l3:integer;
          begin
            l1:=Pos( par_keyword, s_in);
            if l1> 0 then begin
              l2 := length(par_keyword);
              l3  := l1 + l2;
              s_1 := copy(s_in,1,l3);

              with a_controls[count2_of_controls].control_dim do begin
                case par_index of
                  1: s_out := s_1 + IntToStr( control_top);
                  2: s_out := s_1 + IntToStr( control_left);
                  3: s_out := s_1 + IntToStr( control_width);
                  4: s_out := s_1 + IntToStr( control_height);
                end;
              end;

            end;
          end;
          {----------------------------}

          function extract_name_from_string( par_s_marker:string):string;
          var
            substr:string;
            i_from, i_to :integer;
          begin
            i_from := Pos(par_s_marker, s_in);
            inc(i_from, length(par_s_marker));
            substr := copy( s_in, i_from, length(s_in)-i_from+1);
            i_to := Pos(' ', substr);
            if i_to > 0 then substr := copy( substr, 1, i_to-1);

            extract_name_from_string := substr;
          end;

          {----------------------------}
          procedure  change_one_value(par_depicting_string:string; par_value:integer);
          var
            s_part1,s_part2,s_part3,substr,s_tot:string;
            l1,l2:integer;
          begin
            l1:= Pos(par_depicting_string, s_out);
            if l1>0 then begin
              inc(l1, length(par_depicting_string));
              s_part1 := copy( s_out, 1, pred(l1));
              substr  := copy( s_out, l1, length(s_out)-l1+1);
              l2      := Pos(' ', substr);
              s_part3 := copy( substr, l2, length(substr)-l2+1);
              s_part2 := IntToStr(par_value);
              s_tot   := Concat(s_part1, s_part2, s_part3);
              s_out   := s_tot
            end else begin
              MessageDlg('WTF???'    +nl+nl+s_out    , mtError  , [mbOk], 0);
              halt;
            end;

          end;
          {----------------------------}

          procedure change_location_values(par_control_num:integer; par_s1,par_s2,par_s3,par_s4:string);
          var
            ctrl_dim : rec_dimension;
          begin
            ctrl_dim := a_controls[par_control_num].control_dim;
            with ctrl_dim do begin
              change_one_value(par_s1, control_left  );
              change_one_value(par_s2, control_top   );
              change_one_value(par_s3, control_width );
              change_one_value(par_s4, control_height)
            end;
          end;

          {----------------------------}

      var
        s_control_type :string;

      begin
        s_out:= s_in;
        if Pos(' AT ', s_in)> 0 then begin
          inc(count2_of_controls);
          if count2_of_controls>1 then begin {main indow excluded from changes}
            if Pos(' WINDOW ', s_in)> 0 then   s_control_type := ''
                                        else   s_control_type := extract_name_from_string(' DEFINE ');

            if s_control_type='TAB' then change_location_values(count2_of_controls, ' , '   ,  ' AT ' , ' WIDTH ' , ' HEIGHT ')
                                    else change_location_values(count2_of_controls, ' AT '  ,  ' , '  , ' WIDTH ' , ' HEIGHT ');
          end;
        end else begin
          if Pos(' DEFINE ', s_in)> 0 then begin
            inc(count2_of_controls);
          end else begin
            font_write( 'FONTNAME'      , 1 );
            font_write( 'FONTSIZE'      , 2 );
            font_write( 'FONTBOLD'      , 3 );
            font_write( 'FONTITALIC'    , 4 );
            font_write( 'FONTUNDERLINE' , 5 );
            font_write( 'FONTSTRIKEOUT' , 6 );
            dim__write( 'ROW   ',1);
            dim__write( 'COL   ',2);
            dim__write( 'WIDTH ',3);
            dim__write( 'HEIGHT',4);
          end;
        end;
        f_elaborate2 := s_out
      end;

      {------------------}

var
  i:integer;
  s1,s2,
  file_in,
  file_out:string;
  l_file_exists:boolean;
begin
  count2_of_controls:=0;
  file_in := FileListBox1.FileName;

  if file_in='' then begin
    MessageDlg('Fmg file not loaded, nothing to save', mtWarning, [mbOK], 0);
    exit
  end;

  Act_Dir := DirectoryListBox1.Directory;
  SaveDialog1.InitialDir := Act_Dir ;
  SaveDialog1.FileName   := file_in ;

  if SaveDialog1.Execute then begin
    file_out := SaveDialog1.FileName;{ 'd:\out.txt';}

    l_file_exists := FileExists(file_out);
    if (     l_file_exists and (MessageDlg('File ' + ExtractFileName(file_out) +' exists, Overvrite?', mtConfirmation, [mbYes, mbNo], 0) = mrYes))
    or ( not l_file_exists )

    then  begin

      AssignFile(Output, file_out);  Rewrite(Output);
      for i:=1 to i2000 do begin
        s1 := a_input[i];
        s2 := f_elaborate2(s1);
        writeln(Output, s2);
      end;
      CloseFile(Output);

      MessageDlg('File saved, OK', mtInformation, [mbOK], 0)
    end else
    MessageDlg('File NOT saved.', mtInformation, [mbOK], 0);
  end;

end;

{========================================}
{========================================}
{========================================}

procedure TF_main.FormResize(Sender: TObject);
var
  wi_max ,he_max,
  i_width,i_height:integer;
begin
  wi_max := SpinEdit1.Value;
  he_max := SpinEdit2.Value;
  with F_main do begin
    i_width  := Width;
    i_height := Height;
    if i_width  > wi_max then i_width  := wi_max;
    if i_width  < wi_min then i_width  := wi_min;
    if i_height > he_max then i_height := he_max;
    if i_height < he_min then i_height := he_min;
    Width    := i_width  ;
    Height   := i_height ;
  end;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.FormCreate(Sender: TObject);
var
 Bitmap: TBitmap;
begin

  App_Dir   := ExtractFilePath  (Application.ExeName) ;
  Bitmap    := TBitmap.Create;
  try
    Bitmap.LoadFromFile(Concat(App_Dir,'bmp\_min_FMG.bmp'));
    Image1.Canvas.Draw(85,30,BitMap);
  finally Bitmap.Free;
  end;

  fillchar(a_controls,sizeof(a_controls),0);
  fillchar(a_check   ,sizeof(a_check   ),0);
  count_of_controls:=0;
  i_count_checked :=0 ;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i,j,k:integer;
  ctrl_dim  : rec_dimension;

begin
  if count_of_controls>1 then
  for i:=2 to count_of_controls do begin
    ctrl_dim  := a_controls[i].control_dim;
    with ctrl_dim do begin
      if  (Y>=control_top)
      and (Y<=control_top + control_height)
      and (X>=control_left)
      and (X<=control_left+control_width)
      then begin
         a_controls[i].checked := not a_controls[i].checked;
         if a_controls[i].checked then begin
           inc(i_count_checked);
           a_check[i_count_checked] := i;
         end else begin
           j:=0;
           repeat
             inc(j)
           until (a_check[j] = i) or (j=n) ;
           if j<i_count_checked then begin
             k:= succ(j);
             for j:=k to i_count_checked do a_check[pred(j)]:=a_check[j];
           end;
           a_check[i_count_checked] := 0;
           dec(i_count_checked);
         end;
      end;
    end;
  end;
  B_refreshClick(Sender);
  BB_undo.Visible :=false;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.BB_fontClick(Sender: TObject);
{----------------}
  function f_in(fs_type:TFontStyle):string;
  begin
    if fs_type in BB_font.Font.Style then f_in := '.T.'
                                     else f_in := '.F.';
  end;
  {----------------}
var
  i:integer;
  ctrl_font : rec_font;

begin
  if FontDialog1.Execute then begin
    BB_font.Font:=FontDialog1.Font;

    with ctrl_font do begin
      control_fontsize      :=  BB_font.Font.Size;
      control_fontname      :=  '"'+BB_font.Font.Name+'"';
      control_fontbold      :=  f_in(fsBold);
      control_fontitalic    :=  f_in(fsItalic);
      control_fontunderline :=  f_in(fsUnderline);
      control_fontstrikeout :=  f_in(fsStrikeout);
    end;

    if count_of_controls>1 then
    for i:=2 to count_of_controls do begin
      if a_controls[i].checked then begin
        a_controls[i].control_font:= ctrl_font
      end;
    end;

    B_refreshClick(Sender)
  end;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.BB_align_leftClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>1 then begin
    a_controls_undo := a_controls;
    no_of_control   := a_check[1];
    i_value      := a_controls[no_of_control].control_dim.control_left;
    for i:=2 to i_count_checked do begin
      no_of_control:= a_check[i];
      a_controls[no_of_control].control_dim.control_left:=i_value
    end;
    B_refreshClick(Sender)
  end else mess1;
end;

{========================================}

procedure TF_main.BB_align_rightClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>1 then begin
    a_controls_undo := a_controls;
    no_of_control   := a_check[1];
    with a_controls[no_of_control].control_dim do i_value := control_left + control_width;
    for i:=2 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do control_left:=i_value - control_width;
    end;
    B_refreshClick(Sender)
  end else mess1;

end;

{========================================}

procedure TF_main.BB_align_topClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>1 then begin
    a_controls_undo := a_controls;
    no_of_control   := a_check[1];
    i_value      := a_controls[no_of_control].control_dim.control_top;
    for i:=2 to i_count_checked do begin
      no_of_control:= a_check[i];
      a_controls[no_of_control].control_dim.control_top:=i_value
    end;
    B_refreshClick(Sender)
  end else mess1;

end;

{========================================}

procedure TF_main.BB_align_bottomClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>1 then begin
    a_controls_undo := a_controls;
    no_of_control   := a_check[1];
    with a_controls[no_of_control].control_dim do i_value := control_top + control_height;
    for i:=2 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do control_top := i_value - control_height;
    end;
    B_refreshClick(Sender)
  end else mess1;

end;

{========================================}

procedure TF_main.BB_align_center_hClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>1 then begin
    a_controls_undo := a_controls;
    no_of_control   := a_check[1];
    with a_controls[no_of_control].control_dim do i_value := control_left + control_width div 2;
    for i:=2 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do control_left := i_value - control_width div 2;
    end;
    B_refreshClick(Sender)
  end else mess1;

end;

{========================================}

procedure TF_main.BB_align_center_vClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>1 then begin
    a_controls_undo := a_controls;
    no_of_control   := a_check[1];
    with a_controls[no_of_control].control_dim do i_value := control_top + control_height div 2;
    for i:=2 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do control_top := i_value - control_height div 2;
    end;
    B_refreshClick(Sender)
  end else mess1;

end;

{========================================}

procedure TF_main.BB_squeez_hClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if control_width >30+i_value then  dec(control_width,  i_value)
    end;
    B_refreshClick(Sender)
  end else mess3;
end;

{========================================}

procedure TF_main.BB_squeez_vClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if control_height >10+i_value then  dec(control_height, i_value)
    end;
    B_refreshClick(Sender)
  end else mess3;
end;

{========================================}

procedure TF_main.BB_expand_hClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if (control_width +control_left+i_value)<Image1.Width then  inc(control_width , i_value)
    end;
    B_refreshClick(Sender)
  end else mess3;
end;

{========================================}

procedure TF_main.BB_expand_vClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if (control_height+control_top +i_value)<Image1.Height then  inc(control_height , i_value)
    end;
    B_refreshClick(Sender)
  end else mess3;
end;

{========================================}

procedure TF_main.BB_move_leftClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if control_left>i_value then  dec(control_left , i_value)
    end;
    B_refreshClick(Sender)
  end else mess2;
end;

{========================================}

procedure TF_main.BB_move_rightClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if (control_width +control_left+i_value)<Image1.Width then  inc(control_left , i_value)
    end;
    B_refreshClick(Sender)
  end else mess2;
end;

{========================================}

procedure TF_main.BB_move_upClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if control_top>i_value then  dec(control_top , i_value)
    end;
    B_refreshClick(Sender)
  end else mess2;
end;

{========================================}

procedure TF_main.BB_move_downClick(Sender: TObject);
var
  i,no_of_control,i_value:integer;
begin
  if i_count_checked>0 then begin
    a_controls_undo := a_controls;
    i_value := SE_skip.Value;
    for i:=1 to i_count_checked do begin
      no_of_control:= a_check[i];
      with a_controls[no_of_control].control_dim do
      if (control_height+control_top +i_value)<Image1.Height then  inc(control_top , i_value)
    end;
    B_refreshClick(Sender)
  end else mess2;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.B_unmark_allClick(Sender: TObject);
var
  i:integer;
begin
  if count_of_controls>0 then begin
    for i:= 2 to count_of_controls do  a_controls[i].checked:=false;
    for i:= 1 to count_of_controls do  a_check   [i]        :=    0;
    i_count_checked := 0;
    B_refreshClick(Sender)
  end;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.B_mark_allClick(Sender: TObject);
var
  i:integer;
begin
  if count_of_controls>0 then begin
    for i:= 2 to count_of_controls       do  a_controls[i].checked:=true;
    for i:= 1 to pred(count_of_controls) do  a_check   [i]        := succ(i);
    i_count_checked := pred(count_of_controls);
    B_refreshClick(Sender)
  end;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.FormActivate(Sender: TObject);
begin
 DirectoryListBox1.Directory:=App_Dir;
 FileListBox1.SetFocus;
end;

{========================================}
{========================================}
{========================================}

procedure TF_main.BB_undoClick(Sender: TObject);
begin
  a_controls :=  a_controls_undo;
  B_refreshClick(Sender);
  BB_undo.Visible :=false;
end;

{========================================}
{========================================}
{========================================}

end.


{

1. load Fmg (click Fmg file in the File_List_Box)
2. repeat
     -select  a few controls
      (click the control boxex on the image)
     -perform the desired action
      (click the action button)
   until satisfied or not have_time
3. if satisfied then save (click save button)



}
